summaryrefslogtreecommitdiff
path: root/include/mrc.sh
diff options
context:
space:
mode:
Diffstat (limited to 'include/mrc.sh')
-rwxr-xr-xinclude/mrc.sh41
1 files changed, 40 insertions, 1 deletions
diff --git a/include/mrc.sh b/include/mrc.sh
index 6a9b0a12..32c68a83 100755
--- a/include/mrc.sh
+++ b/include/mrc.sh
@@ -1,11 +1,25 @@
# SPDX-License-Identifier: GPL-2.0-only
# Logic based on util/chromeos/crosfirmware.sh in coreboot cfc26ce278.
-# Modifications in this version are Copyright 2021 and 2023 Leah Rowe.
+# Modifications in this version are Copyright 2021, 2023 and 2024 Leah Rowe.
# Original copyright detailed in repo: https://review.coreboot.org/coreboot/
eval "$(setvars "" MRC_url MRC_url_bkup MRC_hash MRC_board SHELLBALL)"
+extract_ref()
+{
+ # refcode needed on broadwell, but not needed on haswell
+
+ # we check mrc twice, because each check only verifies one file,
+ # but refcode is downloaded alongside mrc. in cases where lbmk
+ # erred, downloading only mrc, we must ensure downloading refcode
+ [ -n "$CONFIG_MRC_FILE" ] || \
+ err "extract_ref $board: CONFIG_MRC_FILE not defined"
+
+ # the extract_mrc function actually downloads the refcode
+ fetch "mrc" "$MRC_url" "$MRC_url_bkup" "$MRC_hash" "$CONFIG_MRC_FILE"
+}
+
extract_mrc()
{
[ -z "$MRC_board" ] && err "extract_mrc $MRC_hash: MRC_board not set"
@@ -22,6 +36,8 @@ extract_mrc()
"${cbfstool}" "${appdir}/"bios.bin extract -n mrc.bin \
-f "$_dest" -r RO_SECTION || err "extract_mrc: cbfstool $_dest"
+
+ [ -n "$CONFIG_REFCODE_BLOB_FILE" ] && extract_refcode; return 0
}
extract_partition()
@@ -40,3 +56,26 @@ extract_partition()
printf "cd /usr/sbin\ndump chromeos-firmwareupdate ${SHELLBALL}\nquit" \
| debugfs "root-a.ext2" || err "can't extract shellball"
}
+
+extract_refcode()
+{
+ _refdest="${CONFIG_REFCODE_BLOB_FILE##*../}"
+ [ -f "$_refdest" ] && return 0
+
+ # cbfstool changed the attributes scheme for stage files,
+ # incompatible with older versions before coreboot 4.14,
+ # so we need coreboot 4.13 cbfstool for certain refcode files
+ [ -n "$cbfstoolref" ] || \
+ err "extract_refcode $board: MRC_refcode_cbtree not set"
+ mkdir -p "${_refdest%/*}" || \
+ err "extract_refcode $board: !mkdir -p ${_refdest%/*}"
+
+ "$cbfstoolref" "$appdir/bios.bin" extract \
+ -m x86 -n fallback/refcode -f "$_refdest" -r RO_SECTION \
+ || err "extract_refcode $board: !cbfstoolref $_refdest"
+
+ # enable the Intel GbE device, if told by offset MRC_refcode_gbe
+ [ -z "$MRC_refcode_gbe" ] || dd if="config/ifd/hp820g2/1.bin" \
+ of="$_refdest" bs=1 seek=$MRC_refcode_gbe count=1 conv=notrunc || \
+ err "extract_refcode $_refdest: byte $MRC_refcode_gbe"; return 0
+}